/**
 * Copyright (C) 1998-2012 enStratusNetworks LLC
 *
 * ====================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ====================================================================
 */

package org.dasein.util.uom;

public class RawValue extends Measured<DimensionlessUnit,Dimensionless> {
    static public final Dimensionless DIMENSIONLESS = new Dimensionless();
    
    static public RawValue valueOf(String str) {
        return Measured.valueOf(RawValue.class, str);
    }
    
    static public RawValue valueOf(Number quantity, String uomName) {
        if( uomName == null || uomName.equals("") ) {
            return new RawValue(quantity);
        }
        throw new IllegalArgumentException("Dimensionless values should not have a unit of measure: " + uomName);
    }
    
    protected RawValue() { }

    public RawValue(Number quantity) {
        super(quantity, RawValue.DIMENSIONLESS);
    }
    
    public RawValue(Number quantity, Dimensionless dim) {
        super(quantity, dim);
    }
}
